/*
 *                                        _
 * Copyright (c) 1990,1991,1992,1993 Stig Ostholm.
 * All Rights Reserved
 *
 *
 * The author takes no responsibility of actions caused by the use of this
 * software and does not guarantee the correctness of the functions.
 *
 * This software may be freely distributed and modified for non-commercial use
 * as long as the copyright notice is kept. If you modify any of the files,
 * pleas add a comment indicating what is modified and who made the
 * modification.
 *
 * If you intend to use this software for commercial purposes, contact the
 * author.
 *
 * If you find any bugs or porting problems, please inform the author about
 * the problem and fixes (if there are any).
 *
 *
 * Additional restrictions due to national laws governing the use, import or
 * export of cryptographic software is the responsibility of the software user,
 * importer or exporter to follow.
 *
 *
 *                                              _
 *                                         Stig Ostholm
 *                                         Chalmers University of Technology
 *                                         Department of Computer Engineering
 *                                         S-412 96 Gothenburg
 *                                         Sweden
 *                                         ----------------------------------
 *                                         Email: ostholm@ce.chalmers.se
 *                                         Phone: +46 31 772 1703
 *                                         Fax:   +46 31 772 3663
 */

/*
 * list of semiweak keys.
 */

#define NO_SEMI_WEAK_KEYS	12

const des_cblock	semiweak_key[NO_SEMI_WEAK_KEYS] = {
#ifdef DES_LSB_FIRST
			{ 0x07, 0x7f, 0x07, 0x7f, 0x8f, 0x7f, 0x8f, 0x7f },
			{ 0x7f, 0x07, 0x7f, 0x07, 0x7f, 0x8f, 0x7f, 0x8f },
			{ 0xf8, 0x7f, 0xf8, 0x7f, 0x70, 0x7f, 0x70, 0x7f },
			{ 0x80, 0x7f, 0x80, 0x7f, 0x80, 0x7f, 0x80, 0x7f },
			{ 0xf8, 0x07, 0xf8, 0x07, 0x70, 0x8f, 0x70, 0x8f },
			{ 0x80, 0x07, 0x80, 0x07, 0x80, 0x8f, 0x80, 0x8f },
			{ 0x7f, 0xf8, 0x7f, 0xf8, 0x7f, 0x70, 0x7f, 0x70 },
			{ 0x07, 0xf8, 0x07, 0xf8, 0x8f, 0x70, 0x8f, 0x70 },
			{ 0x7f, 0x80, 0x7f, 0x80, 0x7f, 0x80, 0x7f, 0x80 },
			{ 0x07, 0x80, 0x07, 0x80, 0x8f, 0x80, 0x8f, 0x80 },
			{ 0x80, 0xf8, 0x80, 0xf8, 0x80, 0x70, 0x80, 0x70 },
			{ 0xf8, 0x80, 0xf8, 0x80, 0x70, 0x80, 0x70, 0x80 }
#else
			{ 0xe0, 0xfe, 0xe0, 0xfe, 0xf1, 0xfe, 0xf1, 0xfe },
			{ 0xfe, 0xe0, 0xfe, 0xe0, 0xfe, 0xf1, 0xfe, 0xf1 },
			{ 0x1f, 0xfe, 0x1f, 0xfe, 0x0e, 0xfe, 0x0e, 0xfe },
			{ 0x01, 0xfe, 0x01, 0xfe, 0x01, 0xfe, 0x01, 0xfe },
			{ 0x1f, 0xe0, 0x1f, 0xe0, 0x0e, 0xf1, 0x0e, 0xf1 },
			{ 0x01, 0xe0, 0x01, 0xe0, 0x01, 0xf1, 0x01, 0xf1 },
			{ 0xfe, 0x1f, 0xfe, 0x1f, 0xfe, 0x0e, 0xfe, 0x0e },
			{ 0xe0, 0x1f, 0xe0, 0x1f, 0xf1, 0x0e, 0xf1, 0x0e },
			{ 0xfe, 0x01, 0xfe, 0x01, 0xfe, 0x01, 0xfe, 0x01 },
			{ 0xe0, 0x01, 0xe0, 0x01, 0xf1, 0x01, 0xf1, 0x01 },
			{ 0x01, 0x1f, 0x01, 0x1f, 0x01, 0x0e, 0x01, 0x0e },
			{ 0x1f, 0x01, 0x1f, 0x01, 0x0e, 0x01, 0x0e, 0x01 }
#endif
		};
